/*
FontDialogTest:  a test of the FontDialog class
Copyright (C) 2002, Scott Haywood

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import java.beans.*;
import java.awt.*;
import java.awt.font.*;
import java.awt.event.*;
import javax.swing.*;
import scotthaywood.ui.FontDialog;

/*
import scotthaywood.ui.FileDisplayDialog;
*/

public class FontDialogTest extends JApplet {

	private void dpl(String s) {
		System.err.println(getClass().getName() + ": " + s);
	}

	Font f = new Font("Lucida Sans", Font.PLAIN, 48);
	{
		dpl("f=" + f);
	}

	{ dpl("============================\nConstructor tests"); }
	private FontDialog x =
		new FontDialog(null, "Hello There"); 
	FontDialog y = new FontDialog(null,  null ); 
	
	{ dpl("============================"); }
	JButton invoke = new JButton("invoke font dialog");
	
	// MyTextField is for displaying text with antialiasing
	//
	class MyTextField extends JTextField {
		private boolean antialias = true;
		public void paintComponent(Graphics graphics) {
			Graphics2D g = (Graphics2D) graphics;
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             (antialias
                              ? RenderingHints.VALUE_ANTIALIAS_ON
                              : RenderingHints.VALUE_ANTIALIAS_OFF));
        	g.setRenderingHint(RenderingHints.KEY_RENDERING,
                             (antialias
                              ? RenderingHints.VALUE_RENDER_QUALITY
                              : RenderingHints.VALUE_RENDER_SPEED));
			super.paintComponent(graphics);
   		}
   		public MyTextField(String s) {
   			super(s);
			//setToolTipText("sample text");
   		}
	}
	
	JTextField label = new MyTextField("This is a test");
	{   label.setFont(f);	}
	
	FontDialog dialog = new FontDialog(f, label.getText());
		
    public static void main(String s[]) {
        JApplet test = new FontDialogTest();
        JFrame f = new JFrame(test.getClass().getName());
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        });
        ((JComponent)f.getContentPane()).setBorder(
        	BorderFactory.createEmptyBorder(32,32,32,32));
        f.getContentPane().add(test, BorderLayout.CENTER);
        test.init();
        //f.setSize(new Dimension(550,250));
        f.pack();
        Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
        f.setLocation((int)(screenDim.width - f.getWidth())/2,
                      (int)(screenDim.height - f.getHeight())/2);
		f.setVisible(true);
    }

    // Methods overriding java.applet.Applet --------------------

    public String getAppletInfo() {
    	return "Copyright 2002, Scott Haywood";
    }

    public String[][] getParameterInfo() {
    	return new String[][] {};
    }

    public void init() {
		invoke.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dialog.set(label.getFont(),label.getText());
				dpl("showing dialog");
				dialog.show();
				dpl("dialog.show() returned");
			}
		});
        getContentPane().setLayout( new BorderLayout() );
        getContentPane().add( invoke, BorderLayout.NORTH );
        getContentPane().add( label, BorderLayout.CENTER );
		dialog.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				dpl("got property '" + e.getPropertyName() + "'");
				dpl("old value = '" + e.getOldValue() + "'");
				dpl("new value = '" + e.getNewValue() + "'");
				String p = e.getPropertyName();
				if (p.equals("font")) {
					label.setFont((Font)e.getNewValue());
					//doLayout();
				}
				else if (p.equals("text")) {
					label.setText((String)e.getNewValue());
					//doLayout();
				}
			}
		});
		
	}
    // -------------------------------------------------------

}

